VERSION 5.00
Begin VB.Form frmConfig 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "XMPlay Systray Configuration"
   ClientHeight    =   2640
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4680
   Icon            =   "frmConfig.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2640
   ScaleWidth      =   4680
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdAbort 
      Cancel          =   -1  'True
      Caption         =   "Abort"
      Height          =   375
      Left            =   1440
      TabIndex        =   6
      Top             =   2160
      Width           =   1455
   End
   Begin VB.CommandButton cmdApply 
      Caption         =   "Apply and Exit"
      Default         =   -1  'True
      Height          =   375
      Left            =   3120
      TabIndex        =   5
      Top             =   2160
      Width           =   1455
   End
   Begin VB.CommandButton cmdBrowse 
      Caption         =   "Browse"
      Height          =   285
      Left            =   3480
      TabIndex        =   4
      Top             =   1680
      Width           =   1095
   End
   Begin VB.TextBox txtIcons 
      Height          =   285
      Left            =   480
      TabIndex        =   3
      Text            =   "txtIcons"
      Top             =   1680
      Width           =   2895
   End
   Begin VB.CheckBox chkStart 
      Caption         =   "Load utility at system startup"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Value           =   1  'Checked
      Width           =   2415
   End
   Begin VB.Image imgPreview 
      Height          =   240
      Left            =   120
      Top             =   1705
      Width           =   240
   End
   Begin VB.Label lblIcons 
      AutoSize        =   -1  'True
      Caption         =   "Choose an icon set:"
      Height          =   195
      Left            =   120
      TabIndex        =   2
      Top             =   1440
      Width           =   1410
   End
   Begin VB.Label lblInfoStartup 
      Height          =   795
      Left            =   120
      TabIndex        =   1
      Top             =   480
      Width           =   4500
   End
End
Attribute VB_Name = "frmConfig"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
DefInt A-Z

Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Private Sub cmdAbort_Click()
    Unload Me
End Sub

Private Sub cmdApply_Click()
    On Local Error Resume Next
    Dim ff As Integer
    
    ff = FreeFile
    Open "xmptray.cfg" For Output As ff
        Print #ff, sIconINIFile
    Close #ff
    
    If chkStart.Value = 0 Then
        RemoveAutoRun "XmPlay Systray Utility"
    Else
        SetAutoRun "XmPlay Systray Utility", """" & App.Path & "\" & App.EXEName & ".exe"" idle"
    
        ff = FreeFile
        Open App.Path & "\start.vbs" For Output As #ff
            Print #ff, "set objShell=CreateObject(""Wscript.Shell"")"
            Print #ff, "wscript.sleep 200"
            Print #ff, "objShell.Run " & String(3, 34) & App.Path & "\" & App.EXEName & ".exe" & String(2, 34) & " idle"""
            Print #ff, "set objShell=Nothing"
        Close #ff
        Call ShellExecute(0&, "open", App.Path & "\start.vbs", vbNullString, vbNullString, vbMinimizedNoFocus)
    End If
    Unload Me
End Sub

Private Sub cmdBrowse_Click()
    Dim sTemp As String
    sTemp = GetOpenName("INI files|*.ini", sIconINIFile)
    If sTemp <> "" Then
        sIconINIFile = sTemp
        txtIcons.Text = sIconINIFile
        ShowPreview
    End If
End Sub

Private Sub Form_Load()
    lblInfoStartup.Caption = "Note: You have to enable this option if you want to display the systray icons automatically." & _
        "In order to uninstall this utility properly, you have to disable this option."
        
    txtIcons.Text = sIconINIFile
    ShowPreview
End Sub

Private Sub Form_Unload(Cancel As Integer)
    End
End Sub

Private Sub txtIcons_Change()
    sIconINIFile = txtIcons.Text
End Sub

Private Sub ShowPreview()
    On Local Error Resume Next
    If Dir(sIconINIFile) = "" Then
        MsgBox sIconINIFile & " does not exist!", vbCritical, Me.Caption
        Exit Sub
    End If
    Dim ff As Integer
    Dim sLine As String, sLines() As String, sIconFile As String
    ff = FreeFile
    Open sIconINIFile For Input As ff
        Err.Clear
        While Not EOF(ff)
            Line Input #ff, sLine
            sLines = Split(sLine, ",")
            If UBound(sLines) >= 0 Then
                sIconFile = sLines(0)
                If InStr(sIconFile, "\") = 0 And InStr(sIconFile, "/") = 0 Then
                    sIconFile = Left(sIconINIFile, InStrRev(sIconINIFile, "\")) & sIconFile
                End If
                imgPreview.Picture = LoadPicture(sIconFile)
            End If
        Wend
        If Err.Number Then
            MsgBox sIconINIFile & " contains at least one invalid icon!", vbCritical, Me.Caption
        End If
    Close ff
End Sub
